﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BPASmartClient.Helper;
using Microsoft.Toolkit.Mvvm.ComponentModel;
using Microsoft.Toolkit.Mvvm.Input;
using Microsoft.Toolkit.Mvvm.Messaging;

namespace BPASmartClient.ViewModel
{
    public class NewShopWindowModel : ObservableObject
    {
        public NewShopWindowModel()
        {
            CloseWindowCommand = new RelayCommand(() => { WeakReferenceMessenger.Default.Send("", "CloseWindow"); });
            CancelCommand = new RelayCommand(() => { WeakReferenceMessenger.Default.Send("", "CloseWindow"); });
            DefineCommand = new RelayCommand(() =>
            {
                ActionManage.GetInstance.Send("ShopPar", new string[] { ShopName, ShopId });
                WeakReferenceMessenger.Default.Send("", "CloseWindow");
            });
        }

        public RelayCommand CloseWindowCommand { get; set; }

        public RelayCommand CancelCommand { get; set; }

        public RelayCommand DefineCommand { get; set; }

        public string ShopName { get { return _mShopName; } set { _mShopName = value; OnPropertyChanged(); } }
        private string _mShopName;

        public string ShopId { get { return _mShopId; } set { _mShopId = value; OnPropertyChanged(); } }
        private string _mShopId;



    }
}
