﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BPASmartClient.Helper;
using Microsoft.Toolkit.Mvvm.ComponentModel;
using Microsoft.Toolkit.Mvvm.Input;
using BPASmartClient.ViewModel.Model;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Windows;

namespace BPASmartClient.ViewModel
{
    public class ShopDeviceConfigViewModel : ObservableObject
    {
        private DeviceConfigModel configModel = new DeviceConfigModel();

        public ShopDeviceConfigViewModel()
        {
            ActionManage.GetInstance.Register(new Action<object[]>((o) =>
            {
                if (o != null && o is string[] par)
                {
                    if (par.Length == 2)
                    {
                        configModel.ShopName = par[0];
                        configModel.ShopId = par[1];
                        deviceConfig.Add(configModel);
                    }
                }
            }), "ShopPar");

            NewDeviceCommand = new RelayCommand<object>(NewDevice);
            RemoveDeviceCommand = new RelayCommand<object>(RemoveDevice);
            NewCommunicationCommand = new RelayCommand<object>(NewCommunication);
            RemoveCommunicationCommand = new RelayCommand<object>(RemoveCommunication);
        }

        private void RemoveCommunication(object? obj)
        {
            if (obj != null && obj is CommunicationModel com)
            {
                if (com != null)
                {
                    int index = Array.FindIndex(deviceConfig.ElementAt(0).deviceModels.ToArray(), p => p.Id == com.DeviceModelId);
                    if (index >= 0 && index < deviceConfig.ElementAt(0).deviceModels.Count)
                    {
                        var res = deviceConfig.ElementAt(0).deviceModels.ElementAt(index).communicationDevcies.FirstOrDefault(p => p.CommunicationName == com.CommunicationName);
                        if (res != null)
                        {
                            deviceConfig.ElementAt(0).deviceModels.ElementAt(index).communicationDevcies.Remove(res);
                        }
                    }
                }
            }
        }

        private void NewCommunication(object? obj)
        {
            if (obj != null && obj is DeviceModel dm)
            {
                if (dm != null)
                {
                    string CommunicationName = string.Empty;
                    int num = 1;
                    while (true)
                    {
                        int index = Array.FindIndex(deviceConfig.ElementAt(0).deviceModels.ToArray(), p => p.DeviceName == dm.DeviceName);
                        if (index >= 0 && index < deviceConfig.ElementAt(0).deviceModels.Count)
                        {
                            var res = deviceConfig.ElementAt(0).deviceModels.ElementAt(index).communicationDevcies.FirstOrDefault(p => p.CommunicationName.Contains($"Communication_{num}"));
                            if (res == null)
                            {
                                deviceConfig.ElementAt(0).deviceModels.ElementAt(index).communicationDevcies.Add(new CommunicationModel()
                                {
                                    CommunicationName = $"Communication_{num}",
                                    DeviceModelId = deviceConfig.ElementAt(0).deviceModels.FirstOrDefault(p => p.DeviceName == dm.DeviceName)?.Id,
                                    communicationPar = new CommunicationPar() { CommunicationType = false }

                                });
                                break;
                            }
                        }
                        else break;
                        num++;
                    }
                }
            }
        }

        private void RemoveDevice(object? obj)
        {
            if (obj != null && deviceConfig.Count == 1)
            {
                string DeviceName = obj?.ToString();
                var res = deviceConfig.ElementAt(0).deviceModels.FirstOrDefault(p => p.DeviceName == DeviceName);
                if (res != null)
                    deviceConfig.ElementAt(0).deviceModels.Remove(res);
            }
        }

        private void NewDevice(object? obj)
        {
            if (obj != null && deviceConfig.Count == 1)
            {
                string DeviceName = string.Empty;
                int num = 1;
                while (true)
                {
                    var res = deviceConfig.ElementAt(0).deviceModels.FirstOrDefault(p => p.DeviceName == $"Device_{num}");
                    if (res == null)
                    {
                        deviceConfig.ElementAt(0).deviceModels.Add(new DeviceModel() { DeviceId = "0", DeviceName = $"Device_{num}", Id = Guid.NewGuid().ToString() });
                        break;
                    }
                    num++;
                }
            }
        }


        public static event EventHandler<PropertyChangedEventArgs> StaticPropertyChanged;
        private static void OnStaticPropertyChanged([CallerMemberName] string PropName = "")
        {
            StaticPropertyChanged?.Invoke(null, new PropertyChangedEventArgs(PropName));
        }


        //public static string DeviceNamePar
        //{
        //    get { return _mDeviceNamePar; }
        //    set
        //    {
        //        _mDeviceNamePar = value;
        //        if (deviceConfig.Count == 1)
        //        {
        //            int index = Array.FindIndex(deviceConfig.ElementAt(0).deviceModels.ToArray(), p => p.DeviceName == DeviceName);
        //            if (index >= 0 && index < deviceConfig.ElementAt(0).deviceModels.Count)
        //            {
        //                deviceConfig.ElementAt(0).deviceModels.ElementAt(index).DeviceName = value;
        //            }
        //        }
        //        OnStaticPropertyChanged();
        //    }
        //}
        //private static string _mDeviceNamePar;

        //public static string DeviceIdPar
        //{
        //    get { return _mDeviceIdPar; }
        //    set
        //    {
        //        _mDeviceIdPar = value;
        //        if (deviceConfig.Count == 1)
        //        {
        //            int index = Array.FindIndex(deviceConfig.ElementAt(0).deviceModels.ToArray(), p => p.DeviceName == DeviceName);
        //            if (index >= 0 && index < deviceConfig.ElementAt(0).deviceModels.Count)
        //            {
        //                deviceConfig.ElementAt(0).deviceModels.ElementAt(index).DeviceId = value;
        //            }
        //        }
        //        OnStaticPropertyChanged();
        //    }
        //}
        //private static string _mDeviceIdPar;

        public static Visibility DeviceParVisibility { get { return _mDeviceParVisibility; } set { _mDeviceParVisibility = value; OnStaticPropertyChanged(); } }
        private static Visibility _mDeviceParVisibility = Visibility.Hidden;
        public static Visibility CommunicationVisibility { get { return _mCommunicationVisibility; } set { _mCommunicationVisibility = value; OnStaticPropertyChanged(); } }
        private static Visibility _mCommunicationVisibility = Visibility.Hidden;




        //public static string DeviceModelId
        //{
        //    get { return _mDeviceModelId; }
        //    set
        //    {
        //        _mDeviceModelId = value;

        //    }
        //}
        //private static string _mDeviceModelId;


        //public static string DeviceName
        //{
        //    get { return _mDeviceName; }
        //    set
        //    {
        //        _mDeviceName = value;
        //        if (deviceConfig.Count == 1)
        //        {
        //            var res = deviceConfig.ElementAt(0).deviceModels.FirstOrDefault(p => p.DeviceName == value);
        //            if (res != null)
        //            {
        //                DeviceIdPar = res.DeviceId;
        //                DeviceNamePar = res.DeviceName;
        //            }
        //        }
        //    }
        //}
        //private static string _mDeviceName;


        //public static string CommunicationName { get; set; }



        /// <summary>
        /// 新建设备
        /// </summary>
        public RelayCommand<object> NewDeviceCommand { get; set; }

        /// <summary>
        /// 删除设备
        /// </summary>
        public RelayCommand<object> RemoveDeviceCommand { get; set; }

        /// <summary>
        /// 新建通讯
        /// </summary>
        public RelayCommand<object> NewCommunicationCommand { get; set; }

        /// <summary>
        /// 删除通讯
        /// </summary>
        public RelayCommand<object> RemoveCommunicationCommand { get; set; }

        public static ObservableCollection<DeviceConfigModel> deviceConfig { get; set; } = new ObservableCollection<DeviceConfigModel>();



    }
}
